"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
var isNullOrUndefined = exports.isNullOrUndefined = function isNullOrUndefined(thing) {
    return isNull(thing) || isUndefined(thing);
};
var isNull = exports.isNull = function isNull(thing) {
    return thing === null;
};
var isUndefined = exports.isUndefined = function isUndefined(thing) {
    return thing === undefined;
};
var anyPromise = exports.anyPromise = function anyPromise(promiseArray) {
    var wrapPromise = function wrapPromise(promise) {
        return new Promise(function (resolve, reject) {
            return promise.then(function (content) {
                var wrappedPromise = {
                    succeeded: true,
                    content: content
                };
                return resolve(wrappedPromise);
            }).catch(function (error) {
                var wrappedPromise = {
                    succeeded: false,
                    content: error
                };
                return resolve(wrappedPromise);
            });
        });
    };
    return new Promise(function (resolve, reject) {
        return Promise.all(promiseArray.map(wrapPromise).map(function (wrappedPromise) {
            return new Promise(function (resolve, reject) {
                return wrappedPromise.then(function (wrappedPromise) {
                    if (wrappedPromise.succeeded) {
                        return reject(wrappedPromise.content);
                    }
                    return resolve(wrappedPromise.content);
                });
            });
        })).then(function (arrayOfPromiseFailures) {
            return reject(arrayOfPromiseFailures);
        }).catch(function (successfulPromiseContent) {
            return resolve(successfulPromiseContent);
        });
    });
};
//# sourceMappingURL=util.js.map